Index: tmp/org.txm.core/src/java/org/txm/importer/INARecords.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/INARecords.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/INARecords.groovy	(revision 881)
@@ -0,0 +1,39 @@
+package org.txm.importer
+
+import org.txm.utils.CsvReader;
+import java.nio.charset.Charset;
+
+File csvFile = new File("/home/mdecorde/xml/notices/MARTICE_20130304_TF1_IMAGO_1994-12-31.csv")
+CsvReader reader = new CsvReader(csvFile.getAbsolutePath(), ";".charAt(0), Charset.forName("UTF-8"))
+
+reader.readHeaders()
+def headers = reader.getHeaders()
+int nheader = headers.size()
+int nlines = 0;
+def counts = new int[nheader]
+def values = [:]
+for (String key : headers) values[key] = new HashSet()
+
+while (reader.readRecord()) {
+	nlines++;
+	for (int i = 0 ; i < nheader ; i++) {
+		String key = headers[i]
+		String str = " "+reader.get(key);
+		//print str
+		if (str.trim().length() > 0) {
+			counts[i] = counts[i] + 1
+			values[key] << str.trim()
+		}
+	}
+	//println ""
+}
+
+println "N lines: "+nlines
+println "Empty cols: N <= 20"
+for (int i = 0 ; i < nheader ; i++) {
+	
+	if (counts[i] < 30) {
+		println ( headers[i]+ " : "+counts[i])
+		println values[headers[i]]
+	}
+}
\ No newline at end of file
Index: tmp/org.txm.core/src/java/org/txm/importer/MetadataGetter.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/MetadataGetter.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/MetadataGetter.groovy	(revision 881)
@@ -0,0 +1,35 @@
+package org.txm.importer
+
+import javax.xml.stream.*;
+
+class MetadataGetter {
+	public static String get(File xmlFile, String struct, String prop) {
+
+		def inputData = xmlFile.toURI().toURL().openStream();
+		def factory = XMLInputFactory.newInstance();
+		XMLStreamReader parser = factory.createXMLStreamReader(inputData);
+
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+			if (event == XMLStreamConstants.START_ELEMENT) {
+				if ("text".equals(parser.getLocalName())) {
+					for (int i = 0 ; i < parser.getAttributeCount() ; i++) {
+						if(prop.equals(parser.getAttributeLocalName(i))) {
+							String tmp = parser.getAttributeValue(i)
+							parser.close()
+							return tmp
+						}
+					}
+				}
+			}
+		}
+		parser.close()
+		return null;
+	}
+
+	public static void main(String[] args) {
+		File xmlFile = new File("/home/mdecorde/TXM/corpora/superphenix/txm/SUPERPHENIX/CreysSuper_04_0175.xml")
+		String struct = "text"
+		String prop = "date"
+		println MetadataGetter.get(xmlFile, struct, prop)
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/GetAttributeValue.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/GetAttributeValue.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/GetAttributeValue.groovy	(revision 881)
@@ -0,0 +1,47 @@
+package org.txm.importer
+
+import java.util.HashMap;
+import java.util.ArrayList;
+import java.io.File;
+import javax.xml.stream.*;
+import java.net.URL;
+
+class GetAttributeValue {
+	public static String process(File xmlFile, String path, String attribute) {
+		String value = "N/A";
+		String currentpath = "";
+		boolean done = false;
+		
+		try {
+			URL url = xmlFile.toURI().toURL();
+			def inputData = url.openStream();
+			def factory = XMLInputFactory.newInstance();
+			XMLStreamReader parser = factory.createXMLStreamReader(inputData);
+			for (int event = parser.next(); !done && event != XMLStreamConstants.END_DOCUMENT; event = parser.next())
+			{
+				switch (event) {
+					case XMLStreamConstants.START_ELEMENT:
+						currentpath += "/"+parser.getLocalName();// append the current tag to the current path
+						if (path == currentpath) {
+							for (int i = 0 ; i < parser.getAttributeCount() ; i++) {
+								if (parser.getAttributeName(i) == attribute) {
+									value = parser.getAttributeValue(i)
+									done = true;
+									break;
+								}
+							}
+						}
+						
+						break;
+					case XMLStreamConstants.END_ELEMENT:
+						currentpath = currentpath.substring(0,currentpath.length() -1 - parser.getLocalName().length()) // remove tag from the path
+						break;
+					
+				}
+			}
+			
+		}
+		catch(Exception e){println("File "+xmlFile+"\n"+e); return "N/A";}
+		return value;
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/WExtract.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/WExtract.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/WExtract.groovy	(revision 881)
@@ -0,0 +1,334 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate: 2015-12-17 12:11:39 +0100 (jeu. 17 déc. 2015) $
+// $LastChangedRevision: 3087 $
+// $LastChangedBy: mdecorde $ 
+//
+package org.txm.importer
+
+import javax.xml.parsers.DocumentBuilder;
+import javax.xml.parsers.DocumentBuilderFactory;
+import javax.xml.parsers.ParserConfigurationException;
+import javax.xml.transform.OutputKeys;
+import javax.xml.transform.Result;
+import javax.xml.transform.Source;
+import javax.xml.transform.Transformer;
+import javax.xml.transform.TransformerFactory;
+import javax.xml.transform.dom.DOMSource;
+import javax.xml.transform.stream.StreamResult;
+
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.NodeList;
+import org.xml.sax.SAXException;
+
+import javax.xml.stream.*;
+import java.io.File;
+import java.net.URL;
+
+// TODO: Auto-generated Javadoc
+/**
+ * Extract w tags from a tei file
+ * not finished.
+ *
+ * @author mdecorde
+ */
+class WExtract 
+{
+	
+	/**
+	 * Process.
+	 *
+	 * @param infile the infile
+	 * @param outfile the outfile
+	 * @param max the max
+	 * @return the java.lang. object
+	 */
+	public process(File infile, File outfile, int max)
+	{
+		println "Process "+infile.getName()+", keep $max words"
+		int count = this.countW(infile);
+		if(count < max)
+		{
+			println "can't extract $max words, the file "+infile.getName()+" contains only $count words"
+			return;
+		}
+		String ms = "#ms_K"
+		int tier = max/3;
+		int from1 = 0 
+		int to1 = tier;
+		int from2 = (count/2) - (tier/2);
+		int to2 =(count/2) + (tier/2);
+		int from3 = count -tier;
+		int to3= count-1;
+		boolean isSic = false;
+		boolean isW = false;
+		boolean isText = false;
+		boolean printW = true;
+		int wcount=0;
+		
+		println " count : "+count
+		println "  get from "+from1+" to "+to1
+		println "  get from "+from2+" to "+to2
+		println "  get from "+from3+" to "+to3
+		
+		
+		String localname;
+		String prefix;
+		InputStream inputData = infile.toURI().toURL().openStream();
+		XMLInputFactory inputfactory = XMLInputFactory.newInstance();
+		XMLStreamReader parser = inputfactory.createXMLStreamReader(inputData);
+		XMLOutputFactory factory = XMLOutputFactory.newInstance();
+		
+		FileOutputStream output = new FileOutputStream(outfile);
+		XMLStreamWriter writer = factory.createXMLStreamWriter(output, "UTF-8");
+		
+		writer.writeStartDocument("utf-8", "1.0");
+		
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) 
+		{
+			if(isText)
+			{
+				if((wcount >= from1 && wcount <= to1 )||
+				(wcount >= from2 && wcount <= to2) ||
+				(wcount >= from3 && wcount <= to3))
+					printW = true;
+				else
+					printW = false;
+			}
+			else
+				printW = true;
+			
+			switch (event) 
+			{
+				case XMLStreamConstants.START_ELEMENT:
+					localname = parser.getLocalName();
+					prefix = parser.getPrefix();
+				
+				/*
+				 if(localname == "supplied")
+				 if(parser.getAttributeValue(null,"source") != null)
+				 ms = parser.getAttributeValue(null,"source")
+				 if(localname == "sic")
+				 {
+				 isSic= true;
+				 }
+				 */
+					if(localname == "text")
+						isText = true;
+				
+					if(localname == "w")
+					{
+						isW= true;
+						wcount++;
+						
+						if(isText)
+						{
+							if((wcount >= from1 && wcount <= to1 )||
+							(wcount >= from2 && wcount <= to2) ||
+							(wcount >= from3 && wcount <= to3))
+								printW = true;
+							else
+								printW = false;
+						}
+						else
+							printW = true;
+					}
+				
+				/*if(!isSic)
+				 if(localname != "choice" && localname != "corr" && localname != "sic" && localname != "supplied" && localname != "seg")
+				 {*/
+					if(localname == "w")
+					{
+						if(printW)
+						{
+							if(prefix != null && prefix.length() > 0)
+								writer.writeStartElement(prefix+":"+localname);
+							else
+								writer.writeStartElement(localname);
+							
+							for(int i= 0 ; i < parser.getAttributeCount() ;i++ )
+							{
+								if(parser.getAttributePrefix(i)!= "")
+									writer.writeAttribute(parser.getAttributePrefix(i)+":"+parser.getAttributeLocalName(i), parser.getAttributeValue(i));
+								else
+									writer.writeAttribute(parser.getAttributeLocalName(i), parser.getAttributeValue(i));
+							}
+							//writer.writeAttribute("srcmf:src", ms);
+						}
+					}
+					else
+					{
+						if(prefix != null && prefix.length() > 0)
+							writer.writeStartElement(prefix+":"+localname);
+						else
+							writer.writeStartElement(localname);
+						
+						if(localname == "teiHeader")
+						{
+							writer.writeAttribute("xmlns:me", "http://www.menota.org/ns/1.0");
+							writer.writeAttribute("xmlns:bfm", "http://bfm.ens-lsh.fr/ns/1.0");
+							//writer.writeAttribute("xmlns:srcmf", "https://listes.cru.fr/wiki/srcmf/index");
+						}
+						
+						if(localname == "TEI")
+						{
+							writer.writeAttribute("xmlns","http://www.tei-c.org/ns/1.0");
+						}
+						
+						for(int i= 0 ; i < parser.getAttributeCount() ;i++ )
+						{
+							if(parser.getAttributePrefix(i)!= "")
+								writer.writeAttribute(parser.getAttributePrefix(i)+":"+parser.getAttributeLocalName(i), parser.getAttributeValue(i));
+							else
+								writer.writeAttribute(parser.getAttributeLocalName(i), parser.getAttributeValue(i));
+						}
+					}
+				//}
+					break;
+				
+				case XMLStreamConstants.END_ELEMENT:
+					localname =parser.getLocalName()
+				
+				/*if(localname == "sic")
+				 isSic= false;
+				 if(localname == "w")
+				 isW= false;
+				 if(localname == "supplied" && ms != "#ms_K")
+				 ms = "#ms_K";
+				 if(!isSic)
+				 if(localname != "choice" && localname != "corr" && localname != "sic" && localname != "supplied" && localname != "seg")
+				 {*/
+					if(localname == "w")
+					{
+						if(printW)
+						{
+							writer.writeEndElement();
+							writer.writeCharacters("\n");
+						}
+					}
+					else
+					{	
+						writer.writeEndElement();
+						writer.writeCharacters("\n");
+					}
+				//	}
+				
+					break;
+				
+				case XMLStreamConstants.CHARACTERS:
+				//if(!isSic)
+					if(isW)
+					{
+						if(printW)
+						{
+							writer.writeCharacters(parser.getText().trim());
+						}
+					}
+					else
+						writer.writeCharacters(parser.getText().trim());
+					break;
+			}
+		}
+		writer.flush();
+		writer.close();
+		output.close()
+		inputData.close();
+	}
+	
+	/**
+	 * Count w.
+	 *
+	 * @param infile the infile
+	 * @return the int
+	 */
+	public int countW(File infile)
+	{
+		InputStream inputData = infile.toURI().toURL().openStream();
+		XMLInputFactory inputfactory = XMLInputFactory.newInstance();
+		XMLStreamReader parser = inputfactory.createXMLStreamReader(inputData);
+		
+		int count = 0;
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) 
+		{
+			switch (event) 
+			{
+				case XMLStreamConstants.START_ELEMENT:
+					if(parser.getLocalName() == "w")
+						count++;
+			}
+		}
+		inputData.close()
+		return count;
+	}
+	
+	/**
+	 * The main method.
+	 *
+	 * @param args the arguments
+	 */
+	public static void main(String[] args)
+	{
+		String userDir = System.getProperty("user.home");
+		
+		File directory = new File(userDir+"/xml/extract/");
+		File outdir = new File(userDir+"/xml/extract/","results");
+		outdir.mkdir();
+		
+		File maxfile = new File(userDir+"/xml/extract/maxfile");
+		/*
+		 * maxfile format:
+		 * 
+		 * filename1.xml	45000
+		 * filename2.xml	22500
+		 * filename3.xml	45000
+		 */
+		HashMap<File, Integer> maxperfile = new HashMap<File, Integer>();
+		maxfile.eachLine{it->
+			String[] split = it.split("\t");
+			if(split.length == 2)
+			{
+				try
+				{
+				String filename = it.split("\t")[0];
+				int max = Integer.parseInt(it.split("\t")[1])
+				maxperfile.put(filename, max);
+				}catch(Exception e ){}
+			}
+		}
+		println maxperfile;
+		
+		def files = directory.listFiles();
+		for(File infile : files)
+		{
+			
+			if(maxperfile.containsKey(infile.getName()))
+			{
+				File outfile = new File(outdir, infile.getName());
+				int max= maxperfile.get(infile.getName());
+				new WExtract().process(infile, outfile, max)
+			}
+		}
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/WExtractWithMode.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/WExtractWithMode.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/WExtractWithMode.groovy	(revision 881)
@@ -0,0 +1,376 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate: 2011-10-19 17:50:26 +0200 (mer., 19 oct. 2011) $
+// $LastChangedRevision: 2038 $
+// $LastChangedBy: alavrentev $ 
+//
+package org.txm.importer
+
+import javax.xml.parsers.DocumentBuilder;
+import javax.xml.parsers.DocumentBuilderFactory;
+import javax.xml.parsers.ParserConfigurationException;
+import javax.xml.transform.OutputKeys;
+import javax.xml.transform.Result;
+import javax.xml.transform.Source;
+import javax.xml.transform.Transformer;
+import javax.xml.transform.TransformerFactory;
+import javax.xml.transform.dom.DOMSource;
+import javax.xml.transform.stream.StreamResult;
+
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.NodeList;
+import org.xml.sax.SAXException;
+
+import javax.xml.stream.*;
+import java.io.File;
+import java.net.URL;
+
+// TODO: Auto-generated Javadoc
+/**
+ * Extract w tags from a tei file
+ * not finished.
+ *
+ * @author mdecorde
+ */
+class WExtractWithMode 
+{
+	
+	/**
+	 * Process.
+	 *
+	 * @param infile the infile
+	 * @param outfile the outfile
+	 * @param max the max
+	 * @return the java.lang. object
+	 */
+	public process(File infile, File outfile, String modemax)
+	{
+		println "Process "+infile.getName()+", keep $modemax words"
+		int count = this.countW(infile);
+		
+		int max = 0
+		String mode = ""
+		
+		try {
+		mode = modemax.split("/")[0]
+		max = Integer.parseInt(modemax.split("/")[1])		
+		}catch(Exception e ){}
+		
+		if(count < max)
+		{
+			println "can't extract $max words, the file "+infile.getName()+" contains only $count words"
+			return;
+		}
+		//String ms = "#ms_K"
+		int part = 0; 
+		if (mode == "3")
+		{
+			part = max/3		
+		}
+		else if (mode == "2")
+		{
+			part = max/2
+		}
+		else if (mode == "1a" || mode == "1m" || mode == "1z")
+		{
+			part = max
+		}
+		else
+		{
+			println "mode must be 1a, 1m, 1z, 2 or 3"
+			return
+		}
+		int from1 = 0 
+		int to1 = 0
+		if (mode != "1m" && mode != "1z")
+		{
+			to1 = part
+		}
+		int from2 = 0
+		int to2 = 0
+		if (mode == "3" || mode == "1m")
+		{
+			from2 = (count/2) - (part/2);
+			to2 =(count/2) + (part/2);			
+		}
+		int from3 = 0
+		int to3 = 0
+		if (mode != "1a" && mode != "1m")
+		{
+			from3 = count -part;
+			to3= count-1;			
+		}
+		boolean isSic = false;
+		boolean isW = false;
+		boolean isText = false;
+		boolean printW = true;
+		int wcount=0;
+		
+		println " count : "+count
+		println "  get from "+from1+" to "+to1
+		println "  get from "+from2+" to "+to2
+		println "  get from "+from3+" to "+to3
+		
+		
+		String localname;
+		String prefix;
+		InputStream inputData = infile.toURI().toURL().openStream();
+		XMLInputFactory inputfactory = XMLInputFactory.newInstance();
+		XMLStreamReader parser = inputfactory.createXMLStreamReader(inputData);
+		XMLOutputFactory factory = XMLOutputFactory.newInstance();
+		
+		FileOutputStream output = new FileOutputStream(outfile)
+		XMLStreamWriter writer = factory.createXMLStreamWriter(output, "UTF-8");
+		
+		writer.writeStartDocument("utf-8", "1.0");
+		
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) 
+		{
+			if(isText)
+			{
+				if((wcount >= from1 && wcount <= to1 )||
+				(wcount >= from2 && wcount <= to2) ||
+				(wcount >= from3 && wcount <= to3))
+					printW = true;
+				else
+					printW = false;
+			}
+			else
+				printW = true;
+			
+			switch (event) 
+			{
+				case XMLStreamConstants.START_ELEMENT:
+					localname = parser.getLocalName();
+					prefix = parser.getPrefix();
+				
+				/*
+				 if(localname == "supplied")
+				 if(parser.getAttributeValue(null,"source") != null)
+				 ms = parser.getAttributeValue(null,"source")
+				 if(localname == "sic")
+				 {
+				 isSic= true;
+				 }
+				 */
+					if(localname == "text")
+						isText = true;
+				
+					if(localname == "w")
+					{
+						isW= true;
+						wcount++;
+						
+						if(isText)
+						{
+							if((wcount >= from1 && wcount <= to1 )||
+							(wcount >= from2 && wcount <= to2) ||
+							(wcount >= from3 && wcount <= to3))
+								printW = true;
+							else
+								printW = false;
+						}
+						else
+							printW = true;
+					}
+				
+				/*if(!isSic)
+				 if(localname != "choice" && localname != "corr" && localname != "sic" && localname != "supplied" && localname != "seg")
+				 {*/
+					if(localname == "w")
+					{
+						if(printW)
+						{
+							if(prefix != null && prefix.length() > 0)
+								writer.writeStartElement(prefix+":"+localname);
+							else
+								writer.writeStartElement(localname);
+							
+							for(int i= 0 ; i < parser.getAttributeCount() ;i++ )
+							{
+								if(parser.getAttributePrefix(i)!= "")
+									writer.writeAttribute(parser.getAttributePrefix(i)+":"+parser.getAttributeLocalName(i), parser.getAttributeValue(i));
+								else
+									writer.writeAttribute(parser.getAttributeLocalName(i), parser.getAttributeValue(i));
+							}
+							//writer.writeAttribute("srcmf:src", ms);
+						}
+					}
+					else
+					{
+						if(prefix != null && prefix.length() > 0)
+							writer.writeStartElement(prefix+":"+localname);
+						else
+							writer.writeStartElement(localname);
+						
+						if(localname == "teiHeader")
+						{
+							writer.writeAttribute("xmlns:me", "http://www.menota.org/ns/1.0");
+							writer.writeAttribute("xmlns:bfm", "http://bfm.ens-lsh.fr/ns/1.0");
+							//writer.writeAttribute("xmlns:srcmf", "https://listes.cru.fr/wiki/srcmf/index");
+						}
+						
+						if(localname == "TEI")
+						{
+							writer.writeAttribute("xmlns","http://www.tei-c.org/ns/1.0");
+						}
+						
+						for(int i= 0 ; i < parser.getAttributeCount() ;i++ )
+						{
+							if(parser.getAttributePrefix(i)!= "")
+								writer.writeAttribute(parser.getAttributePrefix(i)+":"+parser.getAttributeLocalName(i), parser.getAttributeValue(i));
+							else
+								writer.writeAttribute(parser.getAttributeLocalName(i), parser.getAttributeValue(i));
+						}
+					}
+				//}
+					break;
+				
+				case XMLStreamConstants.END_ELEMENT:
+					localname =parser.getLocalName()
+				
+				/*if(localname == "sic")
+				 isSic= false;
+				 if(localname == "w")
+				 isW= false;
+				 if(localname == "supplied" && ms != "#ms_K")
+				 ms = "#ms_K";
+				 if(!isSic)
+				 if(localname != "choice" && localname != "corr" && localname != "sic" && localname != "supplied" && localname != "seg")
+				 {*/
+					if(localname == "w")
+					{
+						if(printW)
+						{
+							writer.writeEndElement();
+							writer.writeCharacters("\n");
+						}
+					}
+					else
+					{	
+						writer.writeEndElement();
+						writer.writeCharacters("\n");
+					}
+				//	}
+				
+					break;
+				
+				case XMLStreamConstants.CHARACTERS:
+				//if(!isSic)
+					if(isW)
+					{
+						if(printW)
+						{
+							writer.writeCharacters(parser.getText().trim());
+						}
+					}
+					else
+						writer.writeCharacters(parser.getText().trim());
+					break;
+			}
+		}
+		writer.flush();
+		writer.close();
+		output.close()
+		inputData.close();
+	}
+	
+	/**
+	 * Count w.
+	 *
+	 * @param infile the infile
+	 * @return the int
+	 */
+	public int countW(File infile)
+	{
+		InputStream inputData = infile.toURI().toURL().openStream();
+		XMLInputFactory inputfactory = XMLInputFactory.newInstance();
+		XMLStreamReader parser = inputfactory.createXMLStreamReader(inputData);
+		
+		int count = 0;
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) 
+		{
+			switch (event) 
+			{
+				case XMLStreamConstants.START_ELEMENT:
+					if(parser.getLocalName() == "w")
+						count++;
+			}
+		}
+		inputData.close()
+		return count;
+	}
+	
+	/**
+	 * The main method.
+	 *
+	 * @param args the arguments
+	 */
+	public static void main(String[] args)
+	{
+		String userDir = System.getProperty("user.home");
+		
+		File directory = new File(userDir+"/xml/extract/");
+		File outdir = new File(userDir+"/xml/extract/","results");
+		outdir.mkdir();
+		
+		File maxfilemode = new File(userDir+"/xml/extract/maxfilemode");
+		/*
+		 * maxfilemode format:
+		 * 
+		 * filename1.xml	3	45000
+		 * filename2.xml	1a	15000
+		 * filename3.xml	1m	15000
+		 * filename4.xml	1z	15000
+		 * filename5.xml	2	22500
+		 */
+		HashMap<File, String> maxperfile = new HashMap<File, String>();
+		maxfilemode.eachLine{it->
+			String[] split = it.split("\t");
+			if(split.length == 3)
+			{
+				try
+				{
+				String filename = it.split("\t")[0];
+				String modemax = it.split("\t")[1]+"/"+it.split("\t")[2]
+				maxperfile.put(filename, modemax);
+				}catch(Exception e ){}
+			}
+		}
+		println maxperfile;
+		
+		def files = directory.listFiles();
+		for(File infile : files)
+		{
+			
+			if(maxperfile.containsKey(infile.getName()))
+			{
+				File outfile = new File(outdir, infile.getName());
+				String modemax = maxperfile.get(infile.getName());
+				new WExtractWithMode().process(infile, outfile, modemax)
+			}
+		}
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/NiceToXML.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/NiceToXML.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/NiceToXML.groovy	(revision 881)
@@ -0,0 +1,202 @@
+package org.txm.importer
+
+import javax.xml.stream.XMLStreamException
+import org.apache.tools.ant.types.resources.selectors.InstanceOf;
+import groovy.xml.*
+
+def root = new File("/home/mdecorde/xml/temoignagesnice/corpus Matrice - fichiers xmlisés/")
+File srcdir = new File(root, "orig");
+File outdir = new File(root, "tmp");
+File okdir = new File(root, "ok");
+File ok2dir = new File(root, "ok2");
+File temoignagedir = new File(root, "temoignages");
+ok2dir.deleteDir()
+ok2dir.mkdir()
+
+//rename title -> head
+for (def file : outdir.listFiles()) {
+	if (!file.getName().endsWith(".xml")) continue;
+	def doc = new XmlParser().parse(file);
+	
+	for (def note : doc.body.chapter.title) {
+		println note
+		note.name = "head"
+	}
+	
+	new File(ok2dir, file.getName()).withWriter("UTF-8") { writer ->
+		new XmlNodePrinter(new PrintWriter(writer)).print(doc)
+	}
+}
+
+/*
+// ADD chapter@title
+for (def file : outdir.listFiles()) {
+	if (!file.getName().endsWith(".xml")) continue;
+	def doc = new XmlParser().parse(file);
+	
+	for (def chapter : doc.body.chapter) {
+		for (def title : chapter.title) {
+			chapter.@title = title.text()
+			break;
+		}
+	}
+	
+	new File(ok2dir, file.getName()).withWriter("UTF-8") { writer ->
+		new XmlNodePrinter(new PrintWriter(writer)).print(doc)
+	}
+}
+*/
+//FIX figure and caption inclusions
+/*
+for (def file : outdir.listFiles()) {
+	if (!file.getName().endsWith(".xml")) continue;
+	def doc = new XmlParser().parse(file);
+	for (def note : doc.body."**".figure) {
+		note.name = "note"
+		//println "fig : $note"
+		//if ("Image :" == note.text()) {
+			def children = note.parent().children()
+			int i = children.indexOf(note)
+			//println i + " < "+children.size()
+			def nextChild = children[i+1]
+			if (nextChild != null && nextChild.name().toString() == "caption") {
+				println nextChild
+
+				note.value = "Images : "+note.text()// + " "+nextChild.text()
+				//println note
+
+				children.remove(i+1)
+				note.append(nextChild)
+			}
+		//}
+	}
+
+	new File(ok2dir, file.getName()).withWriter("UTF-8") { writer ->
+		new XmlNodePrinter(new PrintWriter(writer)).print(doc)
+	}
+}
+*/
+/*
+// DOCBOOK -> DOCBOOK TEXT ONLY
+for (def file : outdir.listFiles()) {
+	def doc = new XmlParser().parse(file);
+
+	def body = null
+	def bookinfo = null
+	def preface = null
+	for (def e : doc.body) body = e
+
+	for (def e : doc.bookinfo) {
+		doc.remove(e)
+	}
+	for (def e : doc.preface) {
+		doc.remove(e)
+	}
+	for (def e : doc.appendix) {
+		doc.remove(e)
+	}
+	for (def e : doc.chapter) {
+		doc.remove(e)
+	}
+
+	if (body == null) {
+		println "error text: "+file
+		continue
+	}
+
+	new File(ok2dir, file.getName()).withWriter("UTF-8") { writer ->
+		new XmlNodePrinter(new PrintWriter(writer)).print(doc)
+	}
+	//		writer.print XmlUtil.serialize(new StreamingMarkupBuilder().bind {
+	//			mkp.yield body
+	//		  })
+}
+*/
+//DOCBOOK to TEI
+/*
+ for (def file : outdir.listFiles()) {
+ def doc = new XmlParser().parse(file);
+ def body = null
+ //def bookinfo = null
+ for (def e : doc.body) body = e
+ //for (def e : doc.bookinfo) bookinfo = e
+ //println body.getClass()
+ if (body == null) {
+ println "error text: "+file
+ continue
+ }
+ //	bookinfo.name = "teiHeader"
+ body.name = "text"
+ def teins = new groovy.xml.Namespace("http://www.tei-c.org/ns/1.0",'tei')
+ //	for (def node : body."**") {
+ //		if (node instanceof String) continue
+ //		def name = node.name()
+ //		if (name instanceof String)
+ //			node.name = teins.get(name)
+ //		else 
+ //			node.name = teins.get(name.getLocalPart())
+ //	}
+ for (def figure : body."**".figure) {
+ figure.name = "note"
+ figure.value = "Image : " + figure.caption.text()
+ }
+ for (def chapter : body."**".chapter) {
+ chapter.name = "div"
+ chapter.@type = "chapter"
+ }
+ for (def caption : body."**".title) {
+ caption.name = "head"
+ }
+ for (def para : body."**".para) {
+ para.name = "p"
+ }
+ def newdoc = new Node(null, "TEI");
+ newdoc.@xmlns="http://www.tei-c.org/ns/1.0";
+ newdoc.append(new Node(null, "teiHeader"))
+ newdoc.append(body)
+ new File(okdir, file.getName()).withWriter("UTF-8") { writer ->
+ new XmlNodePrinter(new PrintWriter(writer)).print(newdoc)
+ }
+ //		writer.print XmlUtil.serialize(new StreamingMarkupBuilder().bind {
+ //			mkp.yield body
+ //		  })
+ }
+ */
+
+// remove TEI
+/*outdir.deleteDir()
+ outdir.mkdir()
+ def errors = []
+ for (def file : srcdir.listFiles()) {
+ if (file.isDirectory()) continue;
+ //new EncodingConverter(file, "Windows-1252", "UTF-8")
+ File outfile = new File(outdir, file.getName());
+ outfile.withWriter("UTF-8") { writer ->
+ file.eachLine("UTF-8") { line ->
+ if (line.trim() == "<TEI>") {
+ } else if (line.trim() == "</TEI>") {
+ writer.println("</book>")
+ } else if (line.trim() == "<book lang=\"fr\"/>") {
+ writer.println("<book lang=\"fr\">")
+ } else {
+ writer.println(line)
+ }
+ }		
+ }
+ try {
+ ValidateXml.testAndThrow(outfile);
+ } catch (XMLStreamException e) {
+ println file.getName() + " : "+ e.getMessage()
+ errors << file
+ if (e.getMessage().contains('Message: The element type "TEI" must be terminated by the matching end-tag "</TEI>"')) {
+ println "Delete line : "+e.location.lineNumber
+ }
+ println ""
+ }
+ }
+ */
+println "done"
+//if (errors.size() > 0)
+//	println ""+errors.size()+" errors : $errors"
+//String content = file.getText("Windows-1252")
+//println content
\ No newline at end of file
Index: tmp/org.txm.core/src/java/org/txm/importer/HTML2XHTML.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/HTML2XHTML.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/HTML2XHTML.groovy	(revision 881)
@@ -0,0 +1,42 @@
+package org.txm.importer
+
+import org.txm.utils.CharsetDetector;
+import org.txm.importer.ValidateXml;
+
+File infile = new File("/home/mdecorde/Bureau/matrice/témoignages/CONVERSIONS/jod/odt.html")
+File outfile = new File("/home/mdecorde/Bureau/matrice/témoignages/CONVERSIONS/jod/odt.xml")
+
+String encoding = new CharsetDetector(infile).getEncoding();
+println "Encoding: $encoding"
+String text = infile.getText(encoding);
+
+//lower case tags
+text = text.replaceAll(/(<[^!][^>]*>)/, 
+	{ full, word -> 
+		//fix attributes TRUC=sdf234
+		word = word.replaceAll("([A-Z]+=)([^\" >]+)([ >])",'$1"$2"$3' )
+		word.toLowerCase() // bourrin
+	} )
+
+//lower case <.> tags
+text = text.replaceAll(/(<.>)/,
+	{ full, word ->
+		word.toLowerCase()
+	} )
+
+//resolve entities
+text = text.replaceAll(/&nbsp;/," ")
+
+//close tags
+text = text.replaceAll(/<br>/,"<br/>")
+text = text.replaceAll(/<meta([^>]*)>/,'<meta$1/>')
+text = text.replaceAll(/<img([^>]*)>/,'<img$1/>')
+
+//remove doctype declaration
+text = text.replace('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">', '')
+
+//write&Validate
+outfile.withWriter(encoding) { writer -> writer.write(text) }
+if (!ValidateXml.test(outfile)) {
+	println "FILE: $outfile"
+}
\ No newline at end of file
